%===========ULAZNI PARAMETRI=============================================
N=10;        %broj tacaka dodira
R=0.5;         %poluprecnik kruga
nn=[0 0 1];  %normala primitiva
np=[-1 0 0]; %supalj primitiv np=[1 0 0], pun primitiv np=[-1 0 0]
O=[0 0 0];
T=[1 0 0 0; 0 1 0 0; 0 0 1 0; 0 0 0 1];             %sistema primitiva u odnosu na kordinatni sistem 
                                                     %radnog predmeta u
                                                     %HOMOGENIM
                                                     %KOORDINATAMA
%========================================================================

d2=0.4*R;    %put brzog hoda
d1=1/5*d2;   %put sporog hoda (mali krug)

for i = 1 : N
    i_n=i-1;
    si=i_n/N;
    h(i)=i+(1-i);
    
    s(i)=R*cos(si*360*pi/180);
    t(i)=R*sin(si*360*pi/180);
    w(i) =si*0;
    
    %formiranje vektora normale
   
    P=cross(nn,np);
    Py=P(1,2);
    if Py==-1;
        
        s_nor(i)=-1*(O(:,1)-s(i))/R;
        t_nor(i)=-1*(O(:,2)-t(i))/R;
        w_nor(i)=-1*(O(:,3)-w(i))/R;
    else
        s_nor(i)=(O(:,1)-s(i))/R;
        t_nor(i)=(O(:,2)-t(i))/R;
        w_nor(i)=(O(:,3)-w(i))/R;
    end
    
    n=[s_nor; t_nor; w_nor];
    
    %formiranje vektora PP1
    s_PP1(i)=s_nor(i)*d1;
    t_PP1(i)=t_nor(i)*d1;
    w_PP1(i)=w_nor(i)*d1;
    
    %formiranje vektora PP2
    s_PP2(i)=s_nor(i)*d2;
    t_PP2(i)=t_nor(i)*d2;
    w_PP2(i)=w_nor(i)*d2;
    
    
    s1(i)=s_PP1(i)+s(i);
    t1(i)=t_PP1(i)+t(i);
    w1(i)=w_PP1(i)+w(i);
    
    s2(i)=s_PP2(i)+s(i);
    t2(i)=t_PP2(i)+t(i);
    w2(i)=w_PP2(i)+w(i);
    
%     P=[s; t; w];
%     P1=[s1; t1; w1];
%     P2=[s2; t2; w2];
    
end
%HOMOGENE KOORDINATE
    P=[s; t; w; h];
    P1=[s1; t1; w1; h];
    P2=[s2; t2; w2; h];

    P=T*P;
    P1=T*P1;
    P2=T*P2;
    
    %KOORDINATE TRANSFORMISANIH TACAKA
    
    P(1,1:N)=P(1,:); %s
    P(2,1:N)=P(2,:); %t
    P(3,1:N)=P(3,:); %w
  
    P1(1,1:N)=P1(1,:); %s1
    P1(2,1:N)=P1(2,:); %t1
    P1(3,1:N)=P1(3,:); %w1
      
    P2(1,1:N)=P2(1,:); %s2
    P2(2,1:N)=P2(2,:); %t2
    P2(3,1:N)=P2(3,:); %w2
                
    Xmo1=[P2(1,:); P1(1,:); P(1,:); P1(1,:)];
    Ymo1=[P2(2,:); P1(2,:); P(2,:); P1(2,:)];
    Zmo1=[P2(3,:); P1(3,:); P(3,:); P1(3,:)];

[m,o] = size(Xmo1);
for k=1:m;
    
    for j= 1 : o
        r=j*m;
        q=r-(m-1);
        Xmo(1,q:r)=Xmo1(:,j);
        Ymo(1,q:r)=Ymo1(:,j);
        Zmo(1,q:r)=Zmo1(:,j);
        
    end
end

Xmo
Ymo
Zmo
%trazene koordinate tacaka
disp P
disp (P)
disp Pi1
disp (P1)
disp Pi2
disp (P2)

%circle
% C=T*[0; 0; 0; 1];
% ang=0:0.01:2*pi;
% xp=R*cos(ang);
% yp=R*sin(ang);
% plot(C(1,1)+xp,C(2,1)+yp);

[X,Y,Z] = cylinder(R,100);
C(1,:)=X(1,:);
C(2,:)=Y(1,:);
C(3,1:101)=-0.1;  %visina cilindra ciji jedan od krugova se posmatra (-)
C(4,1:101)=1;

C1(1,:)=X(2,:);
C1(2,:)=Y(2,:);
C1(3,1:101)=0.1;  %visina cilindra ciji jedan od krugova se posmatra (+)
C1(4,1:101)=1;

TC=T*C;
TC1=T*C1;

X(1,:)=TC(1,:);
X(2,:)=TC1(1,:);
Y(1,:)=TC(2,:);
Y(2,:)=TC1(2,:);
Z(1,:)=TC(3,:);
Z(2,:)=TC1(3,:);
X;
Y;
Z;
testsubject = surf(X,Y,Z);
set(testsubject,'FaceColor',[0.9 0.4 0.2],'FaceAlpha',0.5,'EdgeColor','no','EdgeAlpha',0.6,...
    'DiffuseStrength',1,'AmbientStrength',1)
hFig = figure(1);

hold on

plot3(P1(1,:),P1(2,:),P1(3,:),'o','markersize',4.5,'markerfacecolor','b','markeredgecolor','b')
plot3(P2(1,:),P2(2,:),P2(3,:),'o','markersize',4.5,'markerfacecolor','red','markeredgecolor','red')
plot3(P(1,:),P(2,:),P(3,:),'o','markersize',4.5,'markerfacecolor','black','markeredgecolor','black')

grid on
set(gca, 'gridlinestyle', '-');

axis([-1 1 -1 1 0 1])
set(gca, 'xtick', -1:0.25:1);
set(gca, 'ytick', -1:0.25:1);
set(gca, 'ztick', 0:0.25:1);

set(gca, 'xtickLabel', {'-1','','-0.5','','0','','0.5','','1'}, 'FontSize', 10,'FontName','Ariel'); 
set(gca, 'ytickLabel', {'-1','','-0.5','','0','','0.5','','1'}, 'FontSize', 10,'FontName','Ariel');
set(gca, 'ztickLabel', {'0','','0.5','','1'}, 'FontSize', 10,'FontName','Ariel');

h = get(gca,'zlim');
xlabel('x [mm]', 'FontSize', 10, 'position', [0 -1.3 h(1)],'FontName','Ariel'); 
ylabel('y [mm]', 'FontSize', 10, 'position', [1.3 0 h(1)],'FontName','Ariel');
zlabel('z [mm]','FontSize', 10,'FontName','Ariel');
view(45,60);

set(hFig, 'units', 'centimeters');
hFigposition = get(hFig, 'position');
set(hFig, 'position', [hFigposition(1) hFigposition(2) 8.5 hFigposition(4)*8.5/hFigposition(3)])